package com.unipi.talepis.protal2022_4_2;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.view.View;
import android.widget.EditText;

import java.util.ArrayList;

public class MainActivity extends AppCompatActivity {
    private MyTTS myTTS;
    EditText editText;
    private static final int VOICE_REC_RESULT = 5345;

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode==VOICE_REC_RESULT && resultCode==RESULT_OK){
            ArrayList<String> recResults = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
            //showMessage("Recognized Text",recResults.toString());
            if (recResults.contains("yellow"))
                getWindow().getDecorView().setBackgroundColor(Color.YELLOW);
            else if (recResults.contains("blue"))
                getWindow().getDecorView().setBackgroundColor(Color.BLUE);
            myTTS.speak(recResults.get(0)+" color selected by user!");
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        myTTS = new MyTTS(getApplicationContext());
        editText = findViewById(R.id.editTextTextPersonName);
    }
    public void speak(View view){
        if (editText.getText().length()>0)
            myTTS.speak(editText.getText().toString());
    }
    public void hear(View view){
        Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
        intent.putExtra(RecognizerIntent.EXTRA_PROMPT,"Please say a color!");
        startActivityForResult(intent,VOICE_REC_RESULT);
    }
    private void showMessage(String title, String message){
        new AlertDialog.Builder(this)
                .setTitle(title)
                .setMessage(message)
                .setCancelable(true)
                .show();
    }
}